<template>
  <div>
    <ul>
      <!-- Vue préfère qu'on fasse des v-for en leur indiquant une
      propriété :key. Vue se servira de cette propriété pour savoir
      exactement quel élément correspond à quel objet/élément de la liste.
      Si on fait une boucle sur des objets venant d'une bdd, la key sera
      souvent l'id de l'item. Sinon, on peut prendre l'index comme ici -->
      <li v-for="(item, index) in list" :key="index">{{item}}</li>
    </ul>
    <!-- Le v-model va lié un input/select/textarea à une propriété
    du contrôleur. Dès qu'on change la valeur de l'input, la valeur de
    la propriété est modifiée et inversement
    On fait ici un event onkeyup en spécifiant qu'il ne sera exécuté
    que si on appuie sur la touche enter -->
    <input type="text" v-model="message" @keyup.enter="addItem()">
    <!-- On fait un event au click sur le bouton qui déclenchera la méthode
    addItem du contrôleur -->
    <button @click="addItem()">Add</button>
  </div>
</template>

<script >
export default {
  /**
   * Les data représentent les variables qui seront accessibles dans le
   * template du component. Il est préférable de les déclarer sous forme
   * d'une fonction renvoyant un objet comme ci dessous.
   */
  data() {
    return {
      message: "bloupo",
      list: ["ga", "zo", "bu"]
    };
  },
  /**
   * Les methods représentent les méthodes qui pourront être utilisé dans
   * le template et assigner à des events dans celui ci
   */
  methods: {
    addItem() {
      this.list.push(this.message);
      this.message = "";
    }
  }
};
</script>

<style lang="scss">
</style>

